

#ifndef hi_nodejs_weak_addon_h
#define hi_nodejs_weak_addon_h

#include <nan.h>

// #include <iostream>
#define LOG(a) \
// cout << a << endl

namespace hi_nodejs
{

    using namespace v8;
    using namespace std;

    class WeakRefWrap
    {
    public:
        Nan::Persistent<Object> weakref;
        Nan::Persistent<Object> target;
        Nan::Persistent<Function> callback;

        WeakRefWrap(Local<Object> &weakref, const Nan::FunctionCallbackInfo<Value> &info);

        ~WeakRefWrap();

        static void OnGCCallback(const Nan::WeakCallbackInfo<WeakRefWrap> &info);
    };

    class WeakRef
    {
    public:
        static Nan::Persistent<Function> Template;

        static WeakRefWrap *UnWrap(Local<Object> weakref);

        static void Constructor(const Nan::FunctionCallbackInfo<Value> &info);

        static void Raw(const Nan::FunctionCallbackInfo<Value> &info);
    };

    // class GCWorker : public Nan::AsyncWorker
    // {
    // public:

        // Nan::Persistent<Function> func;

        // GCWorker(Nan::Persistent<Function> &func);

        // virtual void Execute();

        // virtual void HandleOKCallback();

    // };

    void CGCallback(Nan::Persistent<Function> &callback);

    void WeakRefExport(Local<Object> exports);

    void WeakGCExport(Local<Object> exports);

    void WeakExport(Local<Object> exports);

} // namespace hi_nodejs

#endif