

#include "./addon.h"

namespace hi_nodejs
{

    using namespace v8;
    using namespace std;

    Nan::Persistent<Function> _GCListener;
    bool _hasGCCallback = false;

    // GCWorker::GCWorker(Nan::Persistent<Function> &func) : Nan::AsyncWorker(NULL)
    // {
    //     this->func.Reset(func);
    // };

    // void GCWorker::Execute() {}

    // void GCWorker::HandleOKCallback()
    // {
    //     Nan::HandleScope scope;
    //     if (!this->func.IsEmpty())
    //     {
    //         Local<Function> func = Nan::New<Function>(this->func);
    //         Nan::Call(func, func, 0, NULL);
    //         this->func.Reset();
    //     }
    //     if (this->callback != nullptr) {
    //         this->callback->Call(0, NULL, async_resource);
    //     }
    // }

    void CGCallback(Nan::Persistent<Function> &callback)
    {
        if (!callback.IsEmpty())
        {
            // 不知道为什么 在 Electron 中运行就要这样用
            // Nan::AsyncQueueWorker(new GCWorker(callback));

            // 标准 Nodejs 下直接 Call 就行了
            Local<Function> func = Nan::New<Function>(callback);
            Nan::Call(func, func, 0, NULL);
        }
    }

    NAN_GC_CALLBACK(GCEpilogueCallback)
    {
        CGCallback(_GCListener);
    }

    void SetGCListener(const Nan::FunctionCallbackInfo<Value> &info)
    {
        if (info[0]->IsFunction())
        {
            _GCListener.Reset(info[0].As<Function>());
            if (!_GCListener.IsEmpty() && _hasGCCallback == false)
            {
                _hasGCCallback = true;
                Nan::AddGCEpilogueCallback(GCEpilogueCallback);
            }
        }
        else
        {
            _GCListener.Reset();
            _hasGCCallback = false;
            Nan::RemoveGCEpilogueCallback(GCEpilogueCallback);
        }
    }

    void RunGC(const Nan::FunctionCallbackInfo<Value> &info)
    {
        V8::SetFlagsFromString("--expose-gc", 11);
        bool minor = Nan::To<bool>(info[0]).FromJust();
        info.GetIsolate()->RequestGarbageCollectionForTesting(minor ? Isolate::kMinorGarbageCollection : Isolate::kFullGarbageCollection);
    }

    void WeakGCExport(Local<Object> exports)
    {
        Nan::HandleScope scope;

        Nan::SetMethod(exports, "runGC", RunGC);

        Nan::SetMethod(exports, "setGCListener", SetGCListener);

    }
} // namespace hi_nodejs