const Weak = require('./index.js');


(() => {
    let obj = {};
    let ref = Weak.create(obj, () => {
        console.log('-- obj to be recycled --');
    });

    console.log(ref.raw());
})();


(() => {
    let obj = { name: 'hi-lib' };
    let proxy = Weak.wrap(obj, () => {
        console.log('-- obj to be recycled --');
    });
    console.log(proxy.name);
    // print "hi-lib"

    // test
    obj = null;
    Weak.runGC(() => {
        console.log(proxy.name);
        // print "undefined"
    });
})();

(() => {
    let obj = { name: 'hi-lib' };
    let dict = Weak.weakDict();

    dict.obj = obj;

    console.log(dict.obj);
    // print "{name: 'hi-lib'}"

    // test
    obj = null;
    Weak.runGC(() => {
        console.log('-- gc --');
        console.log(dict.obj);
        // print "undefined"
    });
})();